/************************************************************
 *
 * 1999 - 2001 (c) Intersect Alliance Pty Ltd.
 *
 * These routines read the audit config file, and populates
 * the audit configuration window, when called.
 *
 *
 * SNARE GUI Version 0.8 Dated 1 October 2001
 ************************************************************
 * V0.9 1Feb02. Added MATCH_EXCLUDE. Also included
 * the 2 new system calls. Different definition, and new
 * function decls.
 *
 ************************************************************/
#define MAX_HOSTID				256		
#define MAX_AUDIT_CONFIG_LINE   8192
#define SMALL_TOKEN_SIZE        64
#define TOKEN_SIZE		256
#define LARGE_TOKEN_SIZE	1024
#define BUFR_SIZE		4096

#define CONFIG_FILENAME "/etc/audit/audit.conf"

#define MATCH_PARTIAL 		1
#define MATCH_EXACT   		2
#define MATCH_REGEXP  		3
#define MATCH_SELECTED  	4
#define MATCH_ALL       	5
#define MATCH_EXCLUDE		6

#define CONFIG_AUDITTYPE        1
#define CONFIG_OBJECTIVES       2
#define CONFIG_EVENTS           3
#define CONFIG_OUTPUT   	    4
#define CONFIG_HOSTID   	    5

#define EVENT_OFF	        0
#define EVENT_ON	        1

#define RETURNCODE_FAILURE	0
#define RETURNCODE_SUCCESS	1
#define RETURNCODE_ANY		2

#define READ_TYPE_FROM_STRUCT   0
#define AUDIT_BY_OBJECTIVE      1
#define AUDIT_BY_EVENT          2
#define AUDIT_TO_NETWORK		3

#define CRITICALITY_CLEAR       0
#define CRITICALITY_INFO        1
#define CRITICALITY_WARNING 	2
#define CRITICALITY_PRIORITY 	3
#define CRITICALITY_CRITICAL 	4

#define SYS_open 		1
#define SYS_creat		2
#define SYS_execve		3
#define SYS_exit		4
#define SYS_mkdir		5
#define SYS_unlink		6
#define SYS_mknod		7
#define SYS_rmdir		8
#define SYS_chown		9
#define SYS_lchown		10
#define SYS_chown32		11
#define SYS_lchown32		12
#define SYS_chmod		13
#define SYS_symlink		14
#define SYS_link		15
#define SYS_rename		16
#define SYS_reboot		17
#define SYS_truncate		18
#define SYS_chroot		19
#define SYS_setuid		20
#define SYS_setreuid		21
#define SYS_setresuid		22
#define SYS_setuid32		23
#define SYS_setreuid32		24
#define SYS_setresuid32		25
#define SYS_setgid		26
#define SYS_setregid		27
#define SYS_setresgid		28
#define SYS_setgid32		29
#define SYS_setregid32		30
#define SYS_setresgid32		31
#define SYS_truncate64		32
#define SYS_socketcall		33
#define SYS_create_module		34

gint read_configuration(GtkWidget *);
gint set_raw_events(GtkWidget *,int);
void trim(char *);
void trimallwhitespace(char *);
int splitobjective(char *, char *, char *, char *, int *, int *);
int getaudittype(char *);
int geteventswitch(char *);
int getheader(char *);
int isaudittype(char *);
int isfilename(char *);
int isheader(char *);
int iscomment(char *);
int eventname2number(char *);
int regmatch(const char *, const char *);
int regmatchi(const char *, const char *);
int GetMatch(const char *, char *);
int GetMatchUser(const char *, char *);
char *gethostident(char *, char *,int);
int isnetwork(char *);
